% Esempio di calcolo della derivata


disp('ESEMPIO: Calcolo rapporto incrementale');


% Definzione della funzione
f = inline('x.^3+1','x');

% Definizione della derivata esatta
fp = inline('3*x.^2','x');

% Definizione della derivata mediante rapp. incrementale
fph = inline('(f(x+h)-f(x))./h','f','x','h');

% Punto su cui valutare la derivata
x = 1;

% Creazione del vettore degli incrementi 
ih = (0:16)';
h = (10.^-ih);

% Valutazione della derivata mediante rapporto incrementale
yp_approx = fph(f,x,h);

% Derivata calcolata esattamente
yp_vera = fp(x);

% Errore assoluto e relativo
err_ass = abs(yp_approx-yp_vera);
err_rel = err_ass./abs(yp_vera);

% Tabella
tabella = [ih,h,repmat(yp_vera,length(h),1),yp_approx,err_ass,err_rel];

% Stampa a video in modo formattato
fprintf('%s\n',repmat('-',1,80));
fprintf('%4s  %8s  %13s %20s %14s %14s\n',...
    'i', 'h','df esatta','Der. prima approx',...
    'Err. Ass.','Err. Rel.');
fprintf('%s\n',repmat('-',1,80));
fprintf('%4d  %8.1e  %9.6e %20.10e %14.5e %14.5e\n',tabella');
fprintf('%s\n',repmat('-',1,80));

%Disegno errori
figure;
h = semilogy(ih,err_rel,'*-');
set(h,'LineWidth',2);
title('Errore relativo nel calcolo rapp. incrementale');
xlabel('h');
