% Errori nella espressione
%
%   (1+eta)-1
% ------------
%      eta
% Analiticamente questa espressione risulta equivalente a 1.


disp('ESEMPIO: Espressione (1+eta)-1)/eta');


% Definzione della funzione
f = inline('((1+eta)-1)./eta','eta');

% Creazione del vettore degli eta
eta = linspace(-1e-7,1e-7,5000);

% Valutazione della funzione nei punti eta
y = f(eta);

% Calcolo errore relativo
err_rel = abs(y-1)./abs(1);

% Visualizzazione della funzione
figure;
h = plot(eta,y);
set(h,'LineWidth',2);
title('Espressione ((1+\eta)-1)/\eta');
xlabel('\eta');

% Visualizzazione dell'errore relativo
figure;
h = plot(eta,err_rel);
set(h,'LineWidth',2);
title('Errore relativo ((1+\eta)-1)/\eta');
xlabel('\eta');
