% Errori nella rappresentazione di due forme matematicamente equivalenti
%
% P1(x) = (x-1)^7
%
% e la sua versione espansa
%
% P2(x) = x^7 - 7x^6 + ...


disp('ESEMPIO: Espressione polinomiale');


% Prima espressione del polinomio (funzione)
P1 = inline('(x-1).^7','x');

% Generazione dei coefficienti del polinomio
% In MatLab i polinomi sono array di coefficienti memorizzati dal grado
% piu' elevato al grado meno elevato
P2 = 1;     % Polinomio costante
for i=1:7,
    P2 = conv(P2,[1 -1]);    % Moltiplica P2 per (x - 1) e salvalo in P2
end

% Scelta dell'intervallo su cui valutare le due espressione polinomiali
x = linspace(1-1e-2,1+1e-2,1000);

% Valutazione della prima espressione
y1 = P1(x);

% Valutazione della seconda espressione polinomiale
% Per valutare i polinomio uso polyval
y2 = polyval(P2,x);

% Disegno a video i dati
figure;
h = plot(x,y2,'b-',x,y1,'r-');
set(h,'LineWidth',2);
legend('P2','P1');
xlabel('x');
title('Valutazione di due espr. polinomiali');
axis tight
