% ESERCIZIO 4
% Esempio di calcolo delle radici equazione di una equazione di secondo grado
% nelle due formulazioni


disp('ESEMPIO: Radici equazione di II grado');


% Chiusura finestre, canc. variabili e schermo
clear all
close all
clc

% Fisso due soluzioni di riferimento
% x1 > x2 positive per facilitarci poi i confronti
x1_esatta = 1e+4;
x2_esatta = 1e-6;

% Calcolo i parametri a, b, e c della equazione a*x^2 + b*x + c
% Fisso a = 1
% E' tale che a*x^2 + b*x + c = (x-x1_esatta)*(x-x2_esatta)
a = 1;
b = -(x1_esatta+x2_esatta);
c = x1_esatta*x2_esatta;

% Radici calcolate con la formula classica
delta = b^2-4*a*c;
x1_algo1 = (-b+sqrt(delta))/(2*a);
x2_algo1 = (-b-sqrt(delta))/(2*a);

% Formulazione numericamente stabile
x1_algo2 = (-b-sign(b)*sqrt(delta))/(2*a);
x2_algo2 = c/a/x1_algo2;

% Routine MatLab
sol = roots([a b c]);
x1_algo3 = sol(1);
x2_algo3 = sol(2);

% Calcolo errore relativi
er_x1_algo1 = abs(x1_algo1-x1_esatta)/abs(x1_esatta);
er_x2_algo1 = abs(x2_algo1-x2_esatta)/abs(x2_esatta);

er_x1_algo2 = abs(x1_algo2-x1_esatta)/abs(x1_esatta);
er_x2_algo2 = abs(x2_algo2-x2_esatta)/abs(x2_esatta);

er_x1_algo3 = abs(x1_algo3-x1_esatta)/abs(x1_esatta);
er_x2_algo3 = abs(x2_algo3-x2_esatta)/abs(x2_esatta);

% Stampa informazioni a video
disp('Visualizzo radici trovate');
fprintf('%10s = %20.15e   %10s = %20.15e\n','x1_esatta',x1_esatta,'x2_esatta',x2_esatta);
fprintf('%10s = %20.15e   %10s = %20.15e\n','x1_algo1',x1_algo1,'x2_algo1',x2_algo1);
fprintf('%10s = %20.15e   %10s = %20.15e\n','x1_algo2',x1_algo2,'x2_algo2',x2_algo2);
fprintf('%10s = %20.15e   %10s = %20.15e\n\n','x1_algo3',x1_algo3,'x2_algo3',x2_algo3);

disp('Visualizzo errori relativi');
fprintf('%10s = %20.15e   %10s = %20.15e\n','er_x1_algo1',er_x1_algo1,'er_x2_algo1',er_x2_algo1);
fprintf('%10s = %20.15e   %10s = %20.15e\n','er_x1_algo2',er_x1_algo2,'er_x2_algo2',er_x2_algo2);
fprintf('%10s = %20.15e   %10s = %20.15e\n','er_x1_algo3',er_x1_algo3,'er_x2_algo3',er_x2_algo3);
